#!/bin/sh
#
#  project:  Generating all 6-critical graphs on the Klein bottle
#  authors:  Ken-ichi Kawarabayashi, Daniel Kral, Jan Kyncl, Bernard Lidicky
#  www:      http://kam.mff.cuni.cz/~bernard/klein
#

### Compiling ###

echo "Compiling ..."

make

##################### Preparing k-minimal ##############

echo "Creating k-minimal graphs ..."

./kminimal > tmp_kminimal

cat tmp_kminimal | sed 's/[^ ]*:[^ ]*//g' > tmp_in_kminimal_to_faces
cat tmp_kminimal | sed 's/[^ ]*:[^ ]*//g' | ./kminimal_to_faces > tmp_kminimal_faces


######################## Preparing K6 ##################

echo "Creating embeddings of K6 on the Klein bottle ..."

## generate all k6
./k6_generator > tmp_k6

## get only the unique
cat tmp_k6 | sed 's/.://g' | sed 's/G//' > tmp_in_k6_isomorfer
cat tmp_k6 | sed 's/.://g' | sed 's/G//' | ./k6_isomorfer > tmp_k6_unique

## convert them to face representation
cat tmp_k6_unique | sed 's/.://g' | sed 's/G//' > tmp_in_k6_to_face_rep
cat tmp_k6_unique | sed 's/.://g' | sed 's/G//' | ./k6_to_face_rep > tmp_k6_faces


####################### Putting all together ###########

echo "Reversing the splitting operation ..."

cat tmp_kminimal_faces | sed 's/[^ ]*:[^ ]*//g' >  "tmp_in_kminimal_faces"
cat tmp_k6_faces       | sed 's/[^ ]*:[^ ]*//g' >  "tmp_in_k6_faces"

./cycle_glue > "out_6-critical_nonisomorf"

echo "It is done :-)"

